#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#include <random>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

random_device gen;
mt19937 rnd(gen());

const int nmax = 2000 * 1000;
const int inf = 2000 * 1000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

string s, t;
vector<int> answer[nmax];

int main() {
    //freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
    //freopen(NAME".in", "r", stdin);freopen(NAME".out", "w", stdout);
    getline(cin, s);
    getline(cin, t);
    int n = s.length();
    int m = t.length();
    for (int i = 0; i <= n; i++) {
        answer[i].assign(m + 1, 0);
    }
    for (int i = 0; i <= n; i++) {
        answer[i][0] = inf;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (s[i - 1] == t[j - 1]) {
                if (answer[i - 1][j] + 1 < answer[i - 1][j - 1]) {
                    answer[i][j] = answer[i - 1][j] + 1;
                } else {
                    answer[i][j] = answer[i - 1][j - 1];
                }
            } else {
                answer[i][j] = answer[i - 1][j];
            }
        }
    }
    int j = m;
    string ans = "";
    for (int i = n; i >= 1; i--) {
        if (s[i - 1] == t[j - 1]) {
            if (answer[i][j] == answer[i - 1][j] + 1) {
                continue;
            } else {
                ans += s[i - 1];
            }
        } else {
            ans += s[i - 1];
        }
    }
    reverse(ans.begin(), ans.end());
    cout << ans << endl;
    return 0;
}

