#include <bits/stdc++.h>
using ll = long long;
using ld = long double;
using namespace std;

constexpr int MAXN = 600001;
using Point = pair<ll, ll>;
using Event = pair<Point, int>;

Event a[MAXN];
int k = 0;

Point operator -(const Point& lhs, const Point& rhs) {
    return { lhs.first - rhs.first, lhs.second - rhs.second };
}

ll operator ^ (const Point& lhs, const Point& rhs) {
    return lhs.first * rhs.second - lhs.second * rhs.first;
}

istream& operator >> (istream& in, Point& p) {
    return in >> p.first >> p.second;
}

bool up(const Point& p) {
    if (p.second != 0) {
        return p.second > 0;
    }

    return p.first > 0;
}

bool cmp(const Point& lhs, const Point& rhs) {
    bool lu = up(lhs), ru = up(rhs);
    if (lu != ru) {
        return lu;
    }

    return (lhs ^ rhs) > 0;
}

int main() {
#ifdef PAUNSVOKNO
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cout.setf(ios::fixed); cout.precision(20); cout.tie(nullptr); cin.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        Point p, p1, p2;
        cin >> p >> p1 >> p2;
        p1 = p1 - p;
        p2 = p2 - p;

        if ((p1 ^ p2) > 0) {
            swap(p1, p2);
        }
        
        p1 = { -p1.second, p1.first };
        p2 = { p2.second, -p2.first };

        a[k++] = { p1, 1 };
        a[k++] = { p2, -1 };

        if (!cmp(p1, p2)) {
            a[k++] = { {1, 0}, 1 };
        }
    }

    sort(a, a + k, [&](const Event& lhs, const Event& rhs) {
        if (cmp(lhs.first, rhs.first)) {
            return true;
        }

        if (cmp(rhs.first, lhs.first)) {
            return false;
        }

        return lhs.second > rhs.second;
    });

    int cur = 0, ans = 0;
    for (int i = 0; i < k; ++i) {
        ans = max(ans, cur += a[i].second);
    }

    cout << ans << "\n";
}