#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n, m, q1, q2, maxball;
    n = atoi(argv[1]);
    m = atoi(argv[2]);
    q1 = atoi(argv[3]);
    q2 = atoi(argv[4]);
    maxball = atoi(argv[5]);

    n = (n > 10 ? rnd.next(n / 10, n) : n);
    m = (m > 10 ? rnd.next(m / 10, m) : m);
    q1 = (q1 > 10 ? rnd.next(q1 / 10, q1) : q1);
    q2 = (q2 > 10 ? rnd.next(q2 / 10, q2) : q2);
    maxball = (maxball > 10 ? rnd.next(maxball / 10, maxball) : maxball);
    
    while (q2 > 10 * n * m)
	    q2 /= 10;

    vector<int> offMax(m);
    vector< vector<int> > ftable(n, vector<int>(m)), table(n, vector<int>(m));
    for (int i = 0; i < m; i++)
        offMax[i] = rnd.next(0, maxball);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            ftable[i][j] = maxball - offMax[j];
            table[i][j] = ftable[i][j] + int(ftable[i][j] == maxball - offMax[j]) * rnd.next(0, offMax[j]);
        }

    cout << n << ' ' << m << ' ' << q1 + q2 << ' ' << maxball << endl;
    for (int i = 0; i < m; i++)
        cout <<	offMax[i] <<	(i + 1 == m ? '\n' : ' ');
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cout << ftable[i][j] << (j + 1 == m ? '\n' : ' ');
    int q = q1 + q2;
    set< pair<int, int> > used;
    for (int i = 0; i < q; i++) {
        int t = rnd.next(1, 2);
        if (q2 == 0 || (t == 1 && q1 > 0)) {
            q1--;
            cout << 1 << ' ' << rnd.next(1, n) << endl;
        } else {
            q2--;
            int I = rnd.next(1, n);
            int J = rnd.next(1, m);
            while (used.count({I, J}) || ftable[I - 1][J - 1] != maxball - offMax[J - 1]) {
                I = rnd.next(1, n);
                J = rnd.next(1, m);
            }
            used.insert({I, J});
            cout << 2 << ' ' << I << ' ' << J << ' ' << table[I - 1][J - 1] << endl;
        }
    }
    return 0;
}