#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

int cha(int a) {
    return ('a' + a <= 'z' ? 'a' + a : 'A' + a - 26);
}

int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);
    if (argc < 3) {
        cerr << "Usage: n, m, trash, seed" << endl;
        return 1;
    }
    string s = "", t = "";
    int n, m, tr;
    n = atoi(argv[1]);
    m = atoi(argv[2]);
    tr = atoi(argv[3]);
    assert(m <= min(n, 52));
    rnd.setSeed(atoi(argv[4]));
    string hey = "";
    for (int i = 0; i < 52; i++) {
        hey += cha(i);
    }
    shuffle(hey.begin(), hey.end());
    for (int i = 0; i < m; i++) {
        t += hey[i];
    }
    while ((int)s.length() < n) {
        s += t;
    }
    while ((int)s.length() > n) {
        s.pop_back();
    }
    for (int i = 0; i < tr; i++) {
        int ind = rnd.next(0, n - 1);
        s[ind] = cha(rnd.next(0, 51));
    }
    cout << s << endl;
    cout << t << endl;
    return 0;
}
