#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

int cha(int a) {
    return ('a' + a <= 'z' ? 'a' + a : 'A' + a - 26);
}

int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);
    if (argc < 3) {
        cerr << "Usage: n, m, maxchar, tr, seed" << endl;
        return 1;
    }
    string s = "", t = "";
    int n, m, cnt, tr;
    n = atoi(argv[1]);
    m = atoi(argv[2]);
    assert(m <= n);
    cnt = atoi(argv[3]);
    tr = atoi(argv[4]);
    rnd.setSeed(atoi(argv[5]));
    for (int i = 0; i < m; i++) {
        t += cha(rnd.next(0, cnt - 1));
    }
    while ((int)s.length() < n) {
        s += t;
    }
    while ((int)s.length() > n) {
        s.pop_back();
    }
    for (int i = 0; i < tr; i++) {
        int ind = rnd.next(0, n - 1);
        s[ind] = cha(rnd.next(0, cnt - 1));
    }
    cout << s << endl;
    cout << t << endl;
    return 0;
}

