import decimal
import sys

def main():
	st = sys.stdin.readline().rstrip()

	decimal.getcontext().prec = len(st) + 3
	decimal.getcontext().rounding = decimal.ROUND_DOWN

	if len(st) >= 100:
		sz = len(st) // 100 + 1

		arr = [st[sz * i: sz * (i + 1)] for i in range(100)]

		number = decimal.Decimal("0");
		for i in range(len(arr)):
			if arr[i] != "":
				number = number * decimal.Decimal("1E" + str(len(arr[i]))) + decimal.Decimal(arr[i])
	else:
		number = decimal.Decimal(st)
    
	sqrt = int(number.sqrt().quantize(decimal.Decimal("1")))
	residue = int(st) - sqrt ** 2
	if (residue == 0):
		sys.stdout.write("1")
	elif (residue <= sqrt + 1):
		sys.stdout.write(str(residue))
	else:
		sys.stdout.write(str(2 * (sqrt + 1) - residue))

main()