rem   *** validation ***
call scripts\run-validator-tests.bat
call scripts\run-checker-tests.bat

rem    *** tests ***
md tests
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 1 -1 1" "tests\04" 4
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 2 -100 100" "tests\05" 5
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 10 -1e6 1e6 | files\add_zeroes.exe" "tests\06" 6
call scripts\gen-input-via-stdout.bat "files\gen_regular.exe 100 8 -1e6 1e6" "tests\07" 7
call scripts\gen-input-via-stdout.bat "files\gen_one_pos.exe 500" "tests\08" 8
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 245 0 -1e6 1e6 | files\add_zeroes.exe" "tests\09" 9
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 245 1 -1e6 1e6 | files\add_zeroes.exe" "tests\10" 10
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 245 2 -1e6 1e6 | files\add_zeroes.exe" "tests\11" 11
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 245 3 -1e6 1e6 | files\add_zeroes.exe" "tests\12" 12
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 500 0 -5 5" "tests\13" 13
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 495 1 -5 5" "tests\14" 14
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 497 2 -5 5" "tests\15" 15
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 499 3 -5 5" "tests\16" 16
call scripts\gen-input-via-stdout.bat "files\gen_regular.exe 500 13 -1e6 1e6" "tests\17" 17
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 500 1e6" "tests\18" 18
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 500 -1e6" "tests\19" 19
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 500 0" "tests\20" 20
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 500 -1e6 1e6" "tests\21" 21
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 248 -1e6 1e6 | files\add_zeroes.exe" "tests\22" 22
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 500 -10 10" "tests\23" 23
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 1000 -1e6 1e6" "tests\24" 24
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 2499 -1e6 1e6 | files\add_zeroes.exe" "tests\25" 25
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 5000 -1e6 1e6" "tests\26" 26
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 5000 -10 10" "tests\27" 27
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 2499 0 -1e6 1e6 | files\add_zeroes.exe" "tests\28" 28
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 2499 1 -1e6 1e6 | files\add_zeroes.exe" "tests\29" 29
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 2499 2 -1e6 1e6 | files\add_zeroes.exe" "tests\30" 30
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 2499 3 -1e6 1e6 | files\add_zeroes.exe" "tests\31" 31
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 5000 0 -50 50" "tests\32" 32
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 4998 1 -50 50" "tests\33" 33
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 4999 2 -50 50" "tests\34" 34
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 4997 3 -50 50" "tests\35" 35
call scripts\gen-input-via-stdout.bat "files\gen_regular.exe 4999 53 -1e6 1e6" "tests\36" 36
call scripts\gen-input-via-stdout.bat "files\gen_regular.exe 4999 7 -1234 1234" "tests\37" 37
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 5000 1e6" "tests\38" 38
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 5000 -1e6" "tests\39" 39
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 5000 0" "tests\40" 40
call scripts\gen-input-via-stdout.bat "files\gen_one_pos.exe 5000" "tests\41" 41
call scripts\gen-input-via-stdout.bat "files\gen_one_pos.exe 4567" "tests\42" 42
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 1e4 -1e9 1e9" "tests\43" 43
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 1e5 -1e9 1e9" "tests\44" 44
call scripts\gen-input-via-stdout.bat "files\gen_random.exe 1e6 -1e9 1e9" "tests\45" 45
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 1e6 -1e9" "tests\46" 46
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 1e6 1e9" "tests\47" 47
call scripts\gen-input-via-stdout.bat "files\gen_equal.exe 1e6 0" "tests\48" 48
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 499999 0 -1e9 1e9 | files\add_zeroes.exe" "tests\49" 49
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 499999 1 -1e9 1e9 | files\add_zeroes.exe" "tests\50" 50
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 499999 2 -1e9 1e9 | files\add_zeroes.exe" "tests\51" 51
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 499999 3 -1e9 1e9 | files\add_zeroes.exe" "tests\52" 52
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 1e6 0 -50 50" "tests\53" 53
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 1e6 1 -100 100" "tests\54" 54
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 1e6 2 -5 5" "tests\55" 55
call scripts\gen-input-via-stdout.bat "files\gen_convex.exe 1e6 3 -1000 1000" "tests\56" 56
call scripts\gen-input-via-stdout.bat "files\gen_one_pos.exe 9e5" "tests\57" 57
call scripts\gen-input-via-stdout.bat "files\gen_regular.exe 1e6 1e3 -1e9 1e9" "tests\58" 58
call scripts\gen-input-via-stdout.bat "files\gen_regular.exe 1e6 50 -1e9 1e9" "tests\59" 59
call scripts\gen-input-via-stdout.bat "files\gen_regular.exe 1e6 1e5 -1e9 1e9" "tests\60" 60
call scripts\gen-answer.bat tests\01 tests\01.a "tests" "0"
call scripts\gen-answer.bat tests\02 tests\02.a "tests" "0"
call scripts\gen-answer.bat tests\03 tests\03.a "tests" "0"
call scripts\gen-answer.bat tests\04 tests\04.a "tests" "1"
call scripts\gen-answer.bat tests\05 tests\05.a "tests" "1"
call scripts\gen-answer.bat tests\06 tests\06.a "tests" "1"
call scripts\gen-answer.bat tests\07 tests\07.a "tests" "1"
call scripts\gen-answer.bat tests\08 tests\08.a "tests" "1"
call scripts\gen-answer.bat tests\09 tests\09.a "tests" "1"
call scripts\gen-answer.bat tests\10 tests\10.a "tests" "1"
call scripts\gen-answer.bat tests\11 tests\11.a "tests" "1"
call scripts\gen-answer.bat tests\12 tests\12.a "tests" "1"
call scripts\gen-answer.bat tests\13 tests\13.a "tests" "1"
call scripts\gen-answer.bat tests\14 tests\14.a "tests" "1"
call scripts\gen-answer.bat tests\15 tests\15.a "tests" "1"
call scripts\gen-answer.bat tests\16 tests\16.a "tests" "1"
call scripts\gen-answer.bat tests\17 tests\17.a "tests" "1"
call scripts\gen-answer.bat tests\18 tests\18.a "tests" "1"
call scripts\gen-answer.bat tests\19 tests\19.a "tests" "1"
call scripts\gen-answer.bat tests\20 tests\20.a "tests" "1"
call scripts\gen-answer.bat tests\21 tests\21.a "tests" "1"
call scripts\gen-answer.bat tests\22 tests\22.a "tests" "1"
call scripts\gen-answer.bat tests\23 tests\23.a "tests" "1"
call scripts\gen-answer.bat tests\24 tests\24.a "tests" "2"
call scripts\gen-answer.bat tests\25 tests\25.a "tests" "2"
call scripts\gen-answer.bat tests\26 tests\26.a "tests" "2"
call scripts\gen-answer.bat tests\27 tests\27.a "tests" "2"
call scripts\gen-answer.bat tests\28 tests\28.a "tests" "2"
call scripts\gen-answer.bat tests\29 tests\29.a "tests" "2"
call scripts\gen-answer.bat tests\30 tests\30.a "tests" "2"
call scripts\gen-answer.bat tests\31 tests\31.a "tests" "2"
call scripts\gen-answer.bat tests\32 tests\32.a "tests" "2"
call scripts\gen-answer.bat tests\33 tests\33.a "tests" "2"
call scripts\gen-answer.bat tests\34 tests\34.a "tests" "2"
call scripts\gen-answer.bat tests\35 tests\35.a "tests" "2"
call scripts\gen-answer.bat tests\36 tests\36.a "tests" "2"
call scripts\gen-answer.bat tests\37 tests\37.a "tests" "2"
call scripts\gen-answer.bat tests\38 tests\38.a "tests" "2"
call scripts\gen-answer.bat tests\39 tests\39.a "tests" "2"
call scripts\gen-answer.bat tests\40 tests\40.a "tests" "2"
call scripts\gen-answer.bat tests\41 tests\41.a "tests" "2"
call scripts\gen-answer.bat tests\42 tests\42.a "tests" "2"
call scripts\gen-answer.bat tests\43 tests\43.a "tests" "3"
call scripts\gen-answer.bat tests\44 tests\44.a "tests" "3"
call scripts\gen-answer.bat tests\45 tests\45.a "tests" "3"
call scripts\gen-answer.bat tests\46 tests\46.a "tests" "3"
call scripts\gen-answer.bat tests\47 tests\47.a "tests" "3"
call scripts\gen-answer.bat tests\48 tests\48.a "tests" "3"
call scripts\gen-answer.bat tests\49 tests\49.a "tests" "3"
call scripts\gen-answer.bat tests\50 tests\50.a "tests" "3"
call scripts\gen-answer.bat tests\51 tests\51.a "tests" "3"
call scripts\gen-answer.bat tests\52 tests\52.a "tests" "3"
call scripts\gen-answer.bat tests\53 tests\53.a "tests" "3"
call scripts\gen-answer.bat tests\54 tests\54.a "tests" "3"
call scripts\gen-answer.bat tests\55 tests\55.a "tests" "3"
call scripts\gen-answer.bat tests\56 tests\56.a "tests" "3"
call scripts\gen-answer.bat tests\57 tests\57.a "tests" "3"
call scripts\gen-answer.bat tests\58 tests\58.a "tests" "3"
call scripts\gen-answer.bat tests\59 tests\59.a "tests" "3"
call scripts\gen-answer.bat tests\60 tests\60.a "tests" "3"

