#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int size = 1000;

int n, m;
vector <int> edges[size];
bool used[size];
int rp[size], lp[size];

bool dfs(int v) {
	used[v] = true;
	for (auto u : edges[v]) {
		if (lp[u] == -1 || (!used[lp[u]] && dfs(lp[u]))) {
			lp[u] = v;
			rp[v] = u;

			return true;
		}
	}

	return false;
}

bool go() {
	for (int i = 0; i < n; i++)
		used[i] = false;
	for (int i = 0; i < n; i++)
		if (!used[i] && rp[i] == -1 && dfs(i))
			return true;

	return false;
}

int main () {
    scanf("%d%d", &n, &m);

    for (int i = 0; i < n; i++)
    	lp[i] = rp[i] = -1;
    int ans = n;
    for (int i = 0; i < m; i++) {
    	int u, v;
    	scanf("%d%d", &u, &v);
    	u--, v--;
    	edges[u].pb(v);
    	if (go()) {
    		ans--;
    	}
    	printf("%d\n", ans);
    }
	
    return 0;
}